import { ThemeOptions } from "@mui/material";

export const typography: ThemeOptions["typography"] = {
  h1: {
    fontSize: "64px",
    fontFamily: "Tiamat Condensed SC",
    fontWeight: 400,
    fontStyle: "normal",
    fontStretch: "normal",
    letterSpacing: 1,
    lineHeight: "64px",
  },
  h2: {
    fontSize: "48px",
    fontFamily: "Roboto",
    fontWeight: 400,
    fontStyle: "normal",
    fontStretch: "normal",
    letterSpacing: "normal",
    lineHeight: "52.8px",
  },
  h3: {
    fontSize: "36px",
    fontFamily: "Roboto",
    fontWeight: 400,
    fontStyle: "normal",
    fontStretch: "normal",
    letterSpacing: "normal",
    lineHeight: "43.2px",
  },
  h4: {
    fontSize: "26px",
    fontFamily: "Roboto",
    fontWeight: 400,
    fontStyle: "normal",
    fontStretch: "normal",
    letterSpacing: "normal",
    lineHeight: "32.5px",
  },
  h5: {
    fontSize: "20px",
    fontFamily: "Roboto",
    fontWeight: 500,
    fontStyle: "normal",
    fontStretch: "normal",
    letterSpacing: "normal",
    lineHeight: "25px",
  },
  h6: {
    fontSize: "16px",
    fontFamily: "Roboto",
    fontWeight: 500,
    fontStyle: "normal",
    fontStretch: "normal",
    letterSpacing: "normal",
    lineHeight: "22.4px",
  },
  body1: {
    fontSize: "16px",
    fontFamily: "Roboto",
    fontWeight: 400,
    fontStyle: "normal",
    fontStretch: "normal",
    letterSpacing: 0.15,
    lineHeight: "24px",
  },
  body2: {
    fontSize: "14px",
    fontFamily: "Roboto",
    fontWeight: 400,
    fontStyle: "normal",
    fontStretch: "normal",
    letterSpacing: 0.15,
    lineHeight: "20.02px",
  },
  subtitle1: {
    fontSize: "16px",
    fontFamily: "Roboto",
    fontWeight: 400,
    fontStyle: "normal",
    fontStretch: "normal",
    letterSpacing: 0.15,
    lineHeight: "28px",
  },
  subtitle2: {
    fontSize: "14px",
    fontFamily: "Roboto",
    fontWeight: 500,
    fontStyle: "normal",
    fontStretch: "normal",
    letterSpacing: 0.1,
    lineHeight: "21.98px",
  },
  overline: {
    fontSize: "12px",
    fontFamily: "Roboto",
    fontWeight: 400,
    fontStyle: "normal",
    fontStretch: "normal",
    letterSpacing: 1,
    lineHeight: "31.92px",
    textTransform: "uppercase",
  },
  caption: {
    fontSize: "12px",
    fontFamily: "Roboto",
    fontWeight: 400,
    fontStyle: "normal",
    fontStretch: "normal",
    letterSpacing: 0.4,
    lineHeight: "19.92px",
  },
};
